diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/RemoteService.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/RemoteService.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/RemoteService.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/RemoteService.java	2017-09-15 16:57:43.013970000 +0900
@@ -0,0 +1,928 @@
+package com.android.server.remote;
+
+import java.io.*;
+import java.net.Socket;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.zip.ZipEntry;
+import java.util.zip.ZipOutputStream;
+
+import com.android.server.devicemanagement.DeviceManagementService;
+//import android.hardware.SensorEventQueue2;
+
+import android.content.Context;
+import android.content.pm.IPackageManager;
+import android.content.res.ABCManager;
+import android.hardware.Sensor;
+import android.hardware.SensorEventListener;
+import android.hardware.input.IInputManager;
+import android.hardware.input.InputManager;
+import android.location.ILocationManager;
+import android.location.Location;
+import android.location.LocationManager;
+import android.media.MediaPlayer;
+import android.os.RemoteCallbackList;
+import android.os.RemoteException;
+import android.os.ServiceManager;
+import android.os.SystemClock;
+import android.os.Vibrator;
+import android.service.collaboroid.IGeneralMessageListener;
+import android.service.devicemanagement.Device;
+import android.service.devicemanagement.IDeviceManagementService;
+import android.service.remote.AppendingObjectOutputStream;
+import android.service.remote.IRemoteService;
+import android.service.remote.RemoteRequest;
+import android.service.remote.SdPackage;
+import android.util.Log;
+import android.util.SparseArray;
+import android.util.SparseIntArray;
+import android.view.KeyEvent;
+import android.view.MotionEvent;
+
+
+public class RemoteService extends IRemoteService.Stub
+{
+	private String dexServerIP = "192.168.219.104";
+	IPackageManager pm = IPackageManager.Stub.asInterface(ServiceManager.getService("package"));
+	private static final String TAG = "RemoteService";
+	// private static final int SERVERPORT = 55555;
+
+	// For Settings
+	// private static boolean isEnabled = false;
+	public static boolean ServerOn = false;
+	public static boolean isConnectedToServer = false;
+
+	private static String serverIP;
+
+	// For Server
+	private Listener server = null;
+	private Thread serverThread = null;
+	private List<String> clientIPs = new ArrayList<String>();
+
+	// For Data Server
+	private DataListener dataServer = null;
+	private Thread dataServerThread = null;
+
+	/*
+	 * private Socket clientSocket; private ObjectInputStream inFromClient;
+	 */
+
+	// For Client
+	private Thread clientThread = null;
+	private List<String> serverIPs = new ArrayList<String>();
+
+	// For handling connected devices
+	public static ArrayList<String> connectedDevices;
+	public static HashMap<String, Socket> deviceToSocket;
+	public static HashMap<String, AppendingObjectOutputStream> deviceToOutput;
+	public static HashMap<String, ObjectInputStream> deviceToInput;
+	public static SparseArray<ArrayList<AppendingObjectOutputStream>> resourceToOutput;
+	public static SparseArray<ArrayList<ObjectInputStream>> resourceToInput;
+	public static ArrayList<AppendingObjectOutputStream> toRemoteActivityServer;
+	public static HashMap<String, Integer> deviceToSN; // device ip to source device number
+
+
+	public static HashMap<String, Socket> deviceToSocketforData; // device ip to source device number for resource and dex
+	public static HashMap<String, AppendingObjectOutputStream> deviceToOutputforData;
+	public static HashMap<String, ObjectInputStream> deviceToInputforData;
+	public static HashMap<String, Integer> deviceToSNforData; // device ip to source device number
+	public static SparseArray<ArrayList<AppendingObjectOutputStream>> resourceToOutputforData;
+	public static SparseArray<ArrayList<ObjectInputStream>> resourceToInputforData;
+
+	/*
+     * devices which wait for response of resource request
+     * device ip to output stream
+     */
+
+	public static HashMap<String, ObjectOutputStream> waitForResponse;
+
+	/*
+	 * private static Socket socketToServer; private static ObjectOutputStream
+	 * out; private static AppendingObjectOutputStream outToServer;
+	 */
+	public static Sender mSender;
+
+	private DeviceManagementService mDeviceService;
+	//private IInputManager im;
+
+	// for SensorEvent
+	public static SparseIntArray mSensorHandles = new SparseIntArray();
+	public static SparseIntArray mTypeToNumber = new SparseIntArray();
+	public static SparseIntArray mNumberToType = new SparseIntArray();
+	private boolean remoteSensorOn = false;
+	public static SensorEventListener mRemoteListener = null;
+
+	// for sending activity
+	public static final int NUM_DUMMY = 2;
+	public static int CURRENT_DUMMY = 2;
+	public String privText = "BUTTON";
+	public static boolean isFirstTime = true;
+	public static ABCManager ABCForDummy[] = new ABCManager[NUM_DUMMY];
+
+	public static Context mContext;
+
+	public static int testValue = 0;
+
+	// for general message
+	private final RemoteCallbackList<IGeneralMessageListener> mListeners = new RemoteCallbackList<IGeneralMessageListener>();
+
+	// native functions
+	//native void setServerOn(boolean flag);
+	//native void sendRemoteEvent(int type, int sensor, float[] values, int accuracy, long timestamp, int sourceDevice);
+
+	public RemoteService(Context context)
+	{
+		mContext = context;
+		mSender = new Sender(context);
+
+		initRemoteService();
+
+	}
+
+	public boolean isServerOn()
+	{
+		return ServerOn;
+	}
+
+	public void initRemoteService()
+	{
+
+
+		connectedDevices = new ArrayList<String>();
+		deviceToOutput = new HashMap<String, AppendingObjectOutputStream>();
+		deviceToInput = new HashMap<String, ObjectInputStream>();
+		deviceToSocket = new HashMap<String, Socket>();
+		resourceToOutput = new SparseArray<ArrayList<AppendingObjectOutputStream>>();
+		resourceToInput = new SparseArray<ArrayList<ObjectInputStream>>();
+
+		waitForResponse = new HashMap<String, ObjectOutputStream>();
+		deviceToSN = new HashMap<String, Integer>();
+		toRemoteActivityServer = new ArrayList<AppendingObjectOutputStream>();
+
+		//SAMD
+		resourceToOutputforData = new SparseArray<ArrayList<AppendingObjectOutputStream>>();
+		resourceToInputforData = new SparseArray<ArrayList<ObjectInputStream>>();
+		deviceToSocketforData = new HashMap<String, Socket>(); // device ip to source device number for resource and dex
+		deviceToOutputforData = new HashMap<String, AppendingObjectOutputStream>();
+		deviceToInputforData = new HashMap<String, ObjectInputStream>();
+		deviceToSNforData = new HashMap<String, Integer>(); // device ip to source device number
+
+		for(int i=0; i<Device.RESOURCE_TYPE_SIZE; i++){
+			resourceToOutput.append(i, new ArrayList<AppendingObjectOutputStream>());
+			resourceToInput.append(i, new ArrayList<ObjectInputStream>());
+			//SAMD
+			resourceToOutputforData.append(i, new ArrayList<AppendingObjectOutputStream>());
+			resourceToInputforData.append(i, new ArrayList<ObjectInputStream>());
+
+		}
+
+
+		mTypeToNumber.put(Sensor.TYPE_ORIENTATION, 0);
+		mTypeToNumber.put(Sensor.TYPE_PROXIMITY, 1);
+
+		mNumberToType.put(0, Sensor.TYPE_ORIENTATION);
+		mNumberToType.put(1, Sensor.TYPE_PROXIMITY);
+
+	}
+
+	public void initConnections()
+	{
+		try
+		{
+			if(connectedDevices.size() > 0)
+				for(String deviceIP : connectedDevices)
+				{
+					deviceToSocket.get(deviceIP).close();
+					deviceToOutput.get(deviceIP).close();
+				}
+		}
+		catch (IOException e)
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+
+		connectedDevices.clear();
+		deviceToOutput.clear();
+		deviceToSocket.clear();
+		//resourceToOutput.clear();
+		waitForResponse.clear();
+		deviceToSN.clear();
+
+		for(int i=0; i<Device.RESOURCE_TYPE_SIZE; i++){
+			resourceToOutput.get(i).clear();
+			resourceToOutputforData.get(i).clear();
+		}
+
+		toRemoteActivityServer.clear();
+
+		mTypeToNumber.clear();
+		mTypeToNumber.put(Sensor.TYPE_ORIENTATION, 0);
+		mTypeToNumber.put(Sensor.TYPE_PROXIMITY, 1);
+
+		mNumberToType.clear();
+		mNumberToType.put(0, Sensor.TYPE_ORIENTATION);
+		mNumberToType.put(1, Sensor.TYPE_PROXIMITY);
+	}
+
+	@Override
+	public boolean startServer()
+	{
+		// TODO Auto-generated method stub
+		//collaboroid settings -> left right button
+		if (!ServerOn)
+		{
+			server = new Listener(mContext);
+			serverThread = new Thread(server);
+			Log.d(TAG, "Starting Listener!");
+			serverThread.start();
+
+
+			//SADM
+			dataServer = new DataListener(mContext);
+			dataServerThread = new Thread(dataServer);
+			Log.d(TAG, "Starting Data Listener");
+			dataServerThread.start();
+
+			ServerOn = true;
+			//setServerOn(true);
+
+			ILocationManager mLocationManager = ILocationManager.Stub.asInterface(ServiceManager.getService("location"));
+			try
+			{
+				mLocationManager.setRemoteProviderEnabled(true);
+			} catch (RemoteException e)
+			{
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+		}
+
+		//Client 1
+		Log.d(TAG, "startServer - onServer: " + ServerOn);
+
+		return ServerOn;
+	}
+
+	@Override
+	public boolean stopServer()
+	{
+		Log.d(TAG, "HELLO - 0");
+
+		// TODO Auto-generated method stub
+		if (ServerOn)
+		{
+			Log.d(TAG, "Stopping Listener: " + serverThread);
+			if (serverThread != null)
+			{
+				server.terminate();
+				serverThread.interrupt();
+
+				//SAMD
+				dataServer.terminate();
+				dataServerThread.interrupt();
+
+				ServerOn = false;
+				//setServerOn(false);
+
+				ILocationManager mLocationManager = ILocationManager.Stub.asInterface(ServiceManager.getService("location"));
+				try
+				{
+					mLocationManager.setRemoteProviderEnabled(false);
+				} catch (RemoteException e)
+				{
+					// TODO Auto-generated catch block
+					e.printStackTrace();
+				}
+			}
+		}
+
+		Log.d(TAG, "End stopServer - onServer: " + ServerOn);
+
+		return !ServerOn;
+	}
+
+	@Override
+	public List<String> getClientIPs(){
+		return clientIPs = Listener.getClientIPs();
+	}
+
+	@Override
+	public List<String> getServerIPs(){
+		return serverIPs;
+	}
+
+
+
+	@Override
+	public void sendAllrequest(RemoteRequest request)
+	{
+		mSender.sendRequestToEveryDevices(request);
+	}
+
+	@Override
+	public void sendAllMusic(int sampleSize, byte[] sampleData, long presentationTime){
+//        Log.d(TAG, "Music testing");
+
+		SdPackage MDtoSend = new SdPackage(sampleSize, sampleData, presentationTime);
+
+
+        /*Collection<AppendingObjectOutputStream> temp = connectedDevices.values();
+        for (AppendingObjectOutputStream outToServer : temp){
+            try {
+                outToServer.writeObject(MDtoSend);
+            } catch (IOException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            }
+        }*/
+	}
+
+	@Override
+	public void setConfiguration()
+	{
+		// TODO Auto-generated method stub
+		Log.d(TAG, "RemoteRequesT!!!!");
+	}
+
+	@Override
+	public void setEnabled(boolean isEnabled) throws RemoteException
+	{
+		// TODO Auto-generated method stub
+		// RemoteRequestHandler.isEnabled = isEnabled;
+	}
+
+	@Override
+	public boolean connectToServer(String ip)
+	{
+
+
+		return isConnectedToServer;
+	}
+
+	@Override
+	public void disconnectToServer()
+	{
+		serverIPs.clear();
+		clientIPs.clear();
+		connectedDevices.clear();
+		if (isConnectedToServer)
+		{
+			clientThread.interrupt();
+
+			// client.terminate();
+			isConnectedToServer = false;
+			// Settings.System.putString(mContext.getContentResolver(),
+			// "enableRemoteRequest", "false");
+			ILocationManager mLocationManager = ILocationManager.Stub.asInterface(ServiceManager.getService("location"));
+			try
+			{
+				mLocationManager.setRemoteProviderEnabled(false);
+			} catch (RemoteException e)
+			{
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+		}
+		// }
+		/*
+		 * catch (InterruptedException e) { // TODO Auto-generated catch block
+		 * e.printStackTrace(); }
+		 */
+	}
+
+	public boolean setRemoteSensorOn(boolean flag, SensorEventListener listener)
+	{
+		remoteSensorOn = flag;
+		mRemoteListener = listener;
+
+		return remoteSensorOn;
+	}
+
+	@Override
+	public boolean sendResourceRequests(List<Device> requestDeviceList) throws RemoteException {
+		// TODO Auto-generated method stub
+		mSender.connectToRemoteDevices(requestDeviceList);
+
+		return true;
+	}
+
+	@Override
+	/*public int[] isAllowedForResource(String device, int[] resources) throws RemoteException
+	{
+		// TODO Auto-generated method stub
+		IDeviceManager deviceManager = IDeviceManager.Stub.asInterface(ServiceManager.getService(Context.DEVICE_MANAGEMENT_SERVICE));
+		ArrayList<Integer> allowed = new ArrayList<Integer>();
+
+		for(int resource : resources)
+			if(deviceManager.isAllowedForResource(device, resource))
+				allowed.add(resource);
+
+		mSender.addRemoteDevice(allowed, device);
+		int[] ret = new int[allowed.size()];
+
+		for(int i=0; i<allowed.size(); i++)
+			ret[i] = allowed.get(i);
+
+		return ret;
+	}*/
+
+	public boolean isAllowedForResource(String deviceName, String deviceIP, int[] resources) throws RemoteException
+	{
+		// TODO Auto-generated method stub
+		IDeviceManagementService deviceManager = IDeviceManagementService.Stub.asInterface(ServiceManager.getService(Context.DEVICE_MANAGEMENT_SERVICE));
+
+		deviceManager.showRequestDialog(deviceName, deviceIP, resources);
+
+		return true;
+	}
+
+	public boolean respondAllowedResources(String deviceIP, int[] resources)
+	{
+		try {
+			// add remote device
+			mSender.addRemoteDevice(resources, deviceIP);
+
+			waitForResponse.get(deviceIP).writeObject(resources);
+			waitForResponse.remove(deviceIP);
+		} catch (IOException e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+		return true;
+	}
+
+
+
+
+	@Override
+	public boolean sendRequest(RemoteRequest request)
+	{
+		if(isConnectedToServer)
+		{
+		}
+		return false;
+	}
+
+	//for MotionEvent
+	@Override
+	public void sendMotionEvent(MotionEvent event)
+	{
+		Log.d(TAG, event.toString());
+		if(isConnectedToServer)
+			mSender.sendMotionEvent(event);
+	}
+
+	// for KeyEvent
+	@Override
+	public void sendKeyEvent(KeyEvent event) throws RemoteException
+	{
+		// TODO Auto-generated method stub
+//		RemoteKeyEvent rke = new RemoteKeyEvent(event.getAction(),
+//				event.getKeyCode(), event.getSource());
+//
+//		if (isConnectedToServer)
+//			client.sendKeyEvent(rke);
+	}
+
+	@Override
+	public void addSensorHandle(int type, int handle)
+	{
+		// TODO Auto-generated method stub
+		Log.d(TAG, mSensorHandles.toString());
+
+		mSensorHandles.put(type, handle);
+	}
+
+	@Override
+	public void removeSensorHandle(int type)
+	{
+		// TODO Auto-generated method stub
+		Log.d(TAG, "type: " + type);
+		mSensorHandles.delete(type);
+	}
+
+	@Override
+	public void sendSensorEvent(int type, int sensor, float[] values,
+								int accuracy, long timestamp)
+	{
+		RemoteSensorEvent rse = new RemoteSensorEvent(type, sensor, values,
+				accuracy, timestamp);
+
+		if (isConnectedToServer)
+			mSender.sendSensorEvent(rse);
+	}
+
+	@Override
+	public int getVideoPlayers(){
+		int numberOfPlayers = 0;
+		if(isConnectedToServer){
+			numberOfPlayers = resourceToOutput.get(Device.RESOURCE_TYPE_VIDEO).size();
+		}
+		return numberOfPlayers;
+	}
+
+	@Override
+	public void sendVideoSignal(int vport){
+		if(isConnectedToServer){
+			mSender.sendVideoSignal(vport);
+		}
+	}
+
+
+	public void sendMusicData(int sampleSize, byte[] sampleData, long presentationTime){
+
+
+		SdPackage MDtoSend = new SdPackage(sampleSize, sampleData, presentationTime);
+
+		if(isConnectedToServer){
+			mSender.sendMusicData(MDtoSend);
+		}
+	}
+
+	@Override
+	public void sendLocation(Location location)
+	{
+		if(isConnectedToServer)
+			mSender.sendLocation(location);
+	}
+
+	Object sendRountTripRequest(RemoteRequest request)
+	{
+		return null;
+	}
+
+
+
+	static String APP_NAME = "Dummy" + CURRENT_DUMMY;
+	static String APP_DATA_DIR = "/data/local/tmp/" + APP_NAME;
+	static String basePkg = "com.collaboroid.dummy" + CURRENT_DUMMY;
+	static String OUT_ODEX_PATH = "/system/priv-app/"+APP_NAME+"/oat/arm64/"+APP_NAME+".odex";
+	static String DEX_PATH = APP_DATA_DIR + "/classes.dex";
+	static String XML_PATH = APP_DATA_DIR + "/AndroidManifest.xml";
+
+	/*
+ 	*
+ 	* Zips a file at a location and places the resulting zip file at the toLocation
+ 	* Example: zipFileAtPath("downloads/myfolder", "downloads/myFolder.zip");
+ 	*/
+	public boolean zipFileAtPath(String sourcePath, String toLocation) {
+		final int BUFFER = 2048;
+
+		File sourceFile = new File(sourcePath);
+		try {
+			BufferedInputStream origin = null;
+			FileOutputStream dest = new FileOutputStream(toLocation);
+			ZipOutputStream out = new ZipOutputStream(new BufferedOutputStream(
+					dest));
+			if (sourceFile.isDirectory()) {
+				zipSubFolder(out, sourceFile, sourceFile.getParent().length());
+			} else {
+				byte data[] = new byte[BUFFER];
+				FileInputStream fi = new FileInputStream(sourcePath);
+				origin = new BufferedInputStream(fi, BUFFER);
+				ZipEntry entry = new ZipEntry(getLastPathComponent(sourcePath));
+				out.putNextEntry(entry);
+				int count;
+				while ((count = origin.read(data, 0, BUFFER)) != -1) {
+					out.write(data, 0, count);
+				}
+			}
+			out.close();
+		} catch (Exception e) {
+			e.printStackTrace();
+			return false;
+		}
+		return true;
+	}
+
+	/*
+	 *
+	 * Zips a subfolder
+	 *
+	 */
+
+	private void zipSubFolder(ZipOutputStream out, File folder,
+							  int basePathLength) throws IOException {
+
+		final int BUFFER = 2048;
+
+		File[] fileList = folder.listFiles();
+		BufferedInputStream origin = null;
+		for (File file : fileList) {
+			if (file.isDirectory()) {
+				zipSubFolder(out, file, basePathLength);
+			} else {
+				byte data[] = new byte[BUFFER];
+				String unmodifiedFilePath = file.getPath();
+				String relativePath = unmodifiedFilePath
+						.substring(basePathLength);
+				FileInputStream fi = new FileInputStream(unmodifiedFilePath);
+				origin = new BufferedInputStream(fi, BUFFER);
+				ZipEntry entry = new ZipEntry(relativePath);
+				out.putNextEntry(entry);
+				int count;
+				while ((count = origin.read(data, 0, BUFFER)) != -1) {
+					out.write(data, 0, count);
+				}
+				origin.close();
+			}
+		}
+	}
+
+	/*
+     * gets the last path component
+     *
+     * Example: getLastPathComponent("downloads/example/fileToZip");
+     * Result: "fileToZip"
+     */
+	public String getLastPathComponent(String filePath) {
+		String[] segments = filePath.split("/");
+		if (segments.length == 0)
+			return "";
+		String lastPathComponent = segments[segments.length - 1];
+		return lastPathComponent;
+	}
+	public void playMusic()
+	{
+		Log.d(TAG, "playMusic - START!");
+		MediaPlayer mp = new MediaPlayer();
+		try
+		{
+			mp.setDataSource("/storage/emulated/legacy/Music/sabbun.mp3");
+			mp.prepare();
+		} catch (IllegalArgumentException e)
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		} catch (SecurityException e)
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		} catch (IllegalStateException e)
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		} catch (IOException e)
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+		// mp.start();
+	}
+
+	public void testMethod(int value)
+	{
+		testValue = value;
+	}
+
+	@Override
+	public void testVibrate() throws RemoteException
+	{
+		// TODO Auto-generated method stub
+//	    ArrayList<Object> para = new ArrayList<Object>();
+//	    para.add("100");
+//	    RemoteRequest request = new RemoteRequest("systemCall", "vibrate", para);
+//
+//        client.send(request);
+		Vibrator v = (Vibrator) mContext.getSystemService(Context.VIBRATOR_SERVICE);
+
+		v.vibrate(200);
+
+	}
+	@Override
+	public void testMusic() throws RemoteException
+	{
+		// TODO Auto-generated method stub
+
+	}
+
+	@Override
+	public void testVideo() throws RemoteException
+	{
+		// TODO Auto-generated method stub
+
+	}
+
+	@Override
+	public void testTouch() throws RemoteException
+	{
+		// TODO Auto-generated method stub
+		IInputManager mInputService = IInputManager.Stub.asInterface(ServiceManager.getService("input"));
+
+		MotionEvent event = MotionEvent.obtain(
+				SystemClock.uptimeMillis(),
+				SystemClock.uptimeMillis(),
+				(MotionEvent.ACTION_DOWN + (1 << 24)),
+				100,
+				100, 0);
+
+		event.setSource(MotionEvent.TOOL_TYPE_FINGER);
+
+		try
+		{
+			if (!mInputService.injectInputEvent(event, InputManager.INJECT_INPUT_EVENT_MODE_WAIT_FOR_RESULT))
+			{
+				Log.d(TAG, "FAIL!!!!!");
+			}
+		}
+		finally
+		{
+			event.recycle();
+		}
+
+		for(int i=1; i<10; i++)
+		{
+			MotionEvent event1 = MotionEvent.obtain(
+					SystemClock.uptimeMillis(),
+					SystemClock.uptimeMillis(),
+					(MotionEvent.ACTION_MOVE + (1 << 24)),
+					100 * i,
+					100 * i, 0);
+
+			event1.setSource(MotionEvent.TOOL_TYPE_FINGER);
+
+			try
+			{
+				if (!mInputService.injectInputEvent(event1, InputManager.INJECT_INPUT_EVENT_MODE_WAIT_FOR_RESULT))
+				{
+					Log.d(TAG, "FAIL!!!!!");
+				}
+			}
+			finally
+			{
+				event.recycle();
+			}
+		}
+
+		MotionEvent event2 = MotionEvent.obtain(
+				SystemClock.uptimeMillis(),
+				SystemClock.uptimeMillis(),
+				(MotionEvent.ACTION_UP + (1 << 24)),
+				900,
+				900, 0);
+
+		event2.setSource(MotionEvent.TOOL_TYPE_FINGER);
+
+		try
+		{
+			if (!mInputService.injectInputEvent(event2, InputManager.INJECT_INPUT_EVENT_MODE_WAIT_FOR_RESULT))
+			{
+				Log.d(TAG, "FAIL!!!!!");
+			}
+		}
+		finally
+		{
+			event.recycle();
+		}
+	}
+
+	@Override
+	public void testKey() throws RemoteException
+	{
+		// TODO Auto-generated method stub
+
+	}
+
+	@Override
+	public void testSensor() throws RemoteException
+	{
+		// TODO Auto-generated method stub
+		new Thread(new Runnable()
+		{
+			@Override
+			public void run()
+			{
+				float[] temp;
+
+				for(int i=0; i<10; i++)
+				{
+					temp = new float[3];
+					temp[0] = 10;
+					temp[1] = 20;
+					temp[2] = 30;
+
+
+					//SensorEvent se = new SensorEvent(temp, 0, 0, 0);
+
+					//Log.d(TAG, remoteSensorOn + " - " + se.toString());
+
+					//sendRemoteEvent(Sensor.TYPE_REMOTE_SENSOR, Sensor.TYPE_REMOTE_SENSOR, temp, 0, 1000, 1);
+
+				/*sendRemoteEvent(3,
+						32,
+						temp,
+						0,
+						System.currentTimeMillis(),
+						1);*/
+
+				}
+			}
+		}).start();
+	}
+
+	@Override
+	public void testLocation() throws RemoteException
+	{
+		// TODO Auto-generated method stub
+		new Thread(new Runnable()
+		{
+			@Override
+			public void run()
+			{
+				ILocationManager mLocationManager = ILocationManager.Stub.asInterface(ServiceManager.getService("location"));
+
+				for(int i=0; i<10; i++)
+				{
+					Location location = new Location(LocationManager.GPS_PROVIDER);
+					//location.setProvider(LocationManager.GPS_PROVIDER);
+					location.setAccuracy(34);
+					location.setTime(System.currentTimeMillis());
+					location.setElapsedRealtimeNanos(SystemClock.elapsedRealtimeNanos());
+					location.setLatitude((Math.random()*10));
+					location.setLongitude((Math.random()*10));
+
+					try
+					{
+						mLocationManager.reportLocation(location, false);
+					}
+					catch (RemoteException e)
+					{
+						// TODO Auto-generated catch block
+						e.printStackTrace();
+					}
+
+					try {
+						Thread.sleep(1000);
+					} catch (InterruptedException e) {
+						// TODO Auto-generated catch block
+						e.printStackTrace();
+					}
+
+//					Location location2 = new Location(LocationManager.REMOTE_PROVIDER);
+					//location.setProvider(LocationManager.GPS_PROVIDER);
+//					location2.setAccuracy(34);
+//					location2.setTime(System.currentTimeMillis());
+//					location2.setElapsedRealtimeNanos(SystemClock.elapsedRealtimeNanos());
+//					location2.setLatitude((10-i)*123.456);
+//					location2.setLongitude((10-i)*123.456);
+//
+//					try
+//					{
+//						mLocationManager.reportLocation(location2, false);
+//					}
+//					catch (RemoteException e)
+//					{
+//						// TODO Auto-generated catch block
+//						e.printStackTrace();
+//					}
+					//location.reset();
+				}
+			}
+		}).start();
+	}
+
+	public void requestMotionEvents() throws RemoteException{
+		ArrayList<Object> para = new ArrayList<Object>();
+		RemoteRequest request = new RemoteRequest("request", "motion", para);
+		sendAllrequest(request);
+	}
+	@Override
+	public void registerListener(IGeneralMessageListener listener) throws RemoteException {
+		// TODO Auto-generated method stub
+		mListeners.register(listener);
+	}
+	@Override
+	public void unregisterListener(IGeneralMessageListener listener) throws RemoteException {
+		// TODO Auto-generated method stub
+		mListeners.unregister(listener);
+	}
+
+	public void sendMessageToListener(String msg)
+	{
+		final int length = mListeners.beginBroadcast();
+		for(int i=0; i<length; i++)
+		{
+			final IGeneralMessageListener listener = mListeners.getBroadcastItem(i);
+			if(listener != null)
+			{
+				try {
+					listener.onMessageReceived(msg);
+				} catch (RemoteException e) {
+					// TODO Auto-generated catch block
+					e.printStackTrace();
+				}
+			}
+		}
+		mListeners.finishBroadcast();
+	}
+	public void refreshDevices(){
+		IDeviceManagementService deviceManager = IDeviceManagementService.Stub.asInterface(ServiceManager.getService(Context.DEVICE_MANAGEMENT_SERVICE));
+		try {
+			deviceManager.getDeviceList(1);
+		} catch (RemoteException e) {
+			e.printStackTrace();
+		}
+	}
+}
diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/ResourceRequest.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/ResourceRequest.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/ResourceRequest.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/ResourceRequest.java	2017-01-29 02:51:16.649856000 +0900
@@ -0,0 +1,27 @@
+package com.android.server.remote;
+
+import java.io.Serializable;
+
+public class ResourceRequest implements Serializable
+{
+	private static final long serialVersionUID = 1L;
+	
+	private String deviceName;
+	private int[] resources;
+	
+	public ResourceRequest(String dn, int[] rs)
+	{
+		deviceName = dn;
+		resources = rs;
+	}
+	
+	public String getDeviceName()
+	{
+		return deviceName;
+	}
+
+	public int[] getRequestedResources()
+	{
+		return resources;
+	}
+}
